
/**
 * Klasse zur Anwendung des Heronverfahrens.
 * 
 * @author (c.albowski) 
 * @version (07-01-2006)
 */
public class Heron
{
	// Instanzvariable
	int anzahlSchritte;
	double argument,startwert;
	double[][] alleWerte;

	/**
	 * Konstruktor fr Objekte der Klasse Heron
	 */
	public Heron()
	{
		// Instanzvariable initialisieren
		anzahlSchritte = 10;
		argument = 15;
		startwert = 3;
	}

	/**
	 * Erhoeht bzw. vermindert die Anzahl der Schritte, mit denen gerechnet werden soll.
	 */
	public void mehrSchritte(boolean ja) {
	    if (ja) anzahlSchritte++; else if (anzahlSchritte>1) anzahlSchritte--;
	}
	
	/**
	 * zeigt die Anzahl der Schritte, mit denen gerechnet werden soll.
	 */
	public int zeigeAnzahlSchritte() {
	    return anzahlSchritte;
	}
	
	/**
	 * Setzt die Zahl, aus der die Wurzel berechnet werden soll.
	 */
	public void setzeWurzel(double argument) {
		if (argument>0) this.argument=argument;
	}
	
	/**
	 * zeigt die Zahl, aus der die Wurzel berechnet werden soll.
	 */
	public double zeigeWurzel() {
		return argument;
	}
	
	/**
	 * Setzt die Zahl, mit der gestartet werden soll.
	 */
	public void setzeStartwert(double startwert) {
		if (startwert>0) this.startwert=startwert;
	}
	
	/**
	 * zeigt die Zahl, mit der gestartet werden soll.
	 */
	public double zeigeStartwert() {
		return startwert;
	}
	
	/**
	 * berechnet den Naeherungswert
	 */
	public double[][] berechne() {
	    alleWerte = new double[2][anzahlSchritte];
	    alleWerte[0][0]=startwert;
	    alleWerte[1][0]=argument/startwert;
	    for (int i=1;i<anzahlSchritte;i++) {
	        alleWerte[0][i]=(alleWerte[0][i-1]+alleWerte[1][i-1])/2;
	        alleWerte[1][i]=argument/alleWerte[0][i];
	    }
	    return alleWerte;
	}
}
